Subject: Re: [PATCH net-next v3] net: tcp: accept old ack during closing

From: Simon Horman <[email-masked]>
Date: Mon, 29 Jan 2024 11:01:08 +0000

On Fri, Jan 26, 2024 at 12:05:19PM +0800, Menglong Dong wrote:
> For now, the packet with an old ack is not accepted if we are in
> FIN_WAIT1 state, which can cause retransmission. Taking the following
> case as an example:
> 
>     Client                               Server
>       |                                    |
>   FIN_WAIT1(Send FIN, seq=10)          FIN_WAIT1(Send FIN, seq=20, ack=10)
>       |                                    |
>       |                                Send ACK(seq=21, ack=11)
>    Recv ACK(seq=21, ack=11)
>       |
>    Recv FIN(seq=20, ack=10)
> 
> In the case above, simultaneous close is happening, and the FIN and ACK
> packet that send from the server is out of order. Then, the FIN will be
> dropped by the client, as it has an old ack. Then, the server has to
> retransmit the FIN, which can cause delay if the server has set the
> SO_LINGER on the socket.
> 
> Old ack is accepted in the ESTABLISHED and TIME_WAIT state, and I think
> it should be better to keep the same logic.
> 
> In this commit, we accept old ack in FIN_WAIT1/FIN_WAIT2/CLOSING/LAST_ACK
> states. Maybe we should limit it to FIN_WAIT1 for now?
> 
> Signed-off-by: Menglong Dong <[email-masked]>
> ---
> v3:
> - fix unsigned/signed compare error

Thanks for the update.

I wish this could be done without a cast.
But I do see that what you have done is
consistent with at least one other use of tcp_ack().

So from that point of view:

Reviewed-by: Simon Horman <[email-masked]>

...